# FXserv IRC services, Copyright (c) 2002 Christian Vandaele
# This program comes with absolutely NO WARRANTY
#
# Should you choose to use and/or modify this source code, please
# do so under the terms of the GNU General Public License under which
# this program is distributed.
#
# $Id: channel.pl

use strict;

if ($] < 5.006) {
  use vars qw(%cfg %flags %irc %services %sock $ts);
} else {
  our (%cfg, %flags, %irc, %services, %sock, $ts);
}

sub check_channel {
  my $bot  = shift;
  my $nick = $services{$bot}->{'nick'};
  my $list;

  if (exists $services{$bot}->{'channel'}) {
    foreach (keys %{$services{$bot}->{'channel'}}) {
      my $chan = $services{$bot}->{'channel'}->{$_}->{'channel'};

      if (exists $irc{'channel'}->{lc($chan)} && exists $irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)}) {
        if ((($services{$bot}->{'channel'}->{lc($chan)}->{'mode'} eq "o") && ($irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)}->{'mode'} & $flags{'channel'}->{'o'})) ||
            (($services{$bot}->{'channel'}->{lc($chan)}->{'mode'} eq "h") && ($irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)}->{'mode'} & $flags{'channel'}->{'h'})) ||
            (($services{$bot}->{'channel'}->{lc($chan)}->{'mode'} eq "v") && ($irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)}->{'mode'} & $flags{'channel'}->{'v'})) ||
            (($services{$bot}->{'channel'}->{lc($chan)}->{'mode'} eq "") && ($irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)}->{'mode'} eq ""))) {
          next;
        } else {
          &serv_part($bot, $chan);
        }
      }

      &serv_join($bot, $chan);
      $list .= $chan . " ";
    }

    if ($list) {
      $list =~ s/\s+$//;
      &putinfo("y", "%s: now monitoring %s", $nick, $list);
      $list = "";
    }

    foreach (keys %{$irc{'channel'}}) {
      my $chan = $irc{'channel'}->{$_}->{'channel'};

      if (exists $irc{'channel'}->{$_}->{'names'}->{lc($nick)} && !exists $services{$bot}->{'channel'}->{lc($chan)}) {
        &serv_part($bot, $chan);
        $list .= $chan . " ";
      }
    }

    if ($list) {
      $list =~ s/\s+$//;
      &putinfo("y", "%s: no longer monitoring %s", $nick, $list);
      $list = "";
    }
  } else {
    foreach (keys %{$irc{'channel'}}) {
      my $chan = $irc{'channel'}->{$_}->{'channel'};

      if (exists $irc{'channel'}->{$_}->{'names'}->{lc($nick)}) {
        &serv_part($bot, $chan);
        $list .= $chan . " ";
      }
    }

    if ($list) {
      $list =~ s/\s+$//;
      &putinfo("y", "%s: no longer monitoring %s", $nick, $list);
      $list = "";
    }
  }

  return 0;
}

sub channel_stats {
  my $chan = shift;

  if (scalar keys %{$irc{'channel'}->{lc($chan)}->{'names'}} > $irc{'channel'}->{lc($chan)}->{'max'}[0]) { @{$irc{'channel'}->{lc($chan)}->{'max'}} = (scalar keys %{$irc{'channel'}->{lc($chan)}->{'names'}}, $ts); }

  if (scalar keys %{$irc{'channel'}} > $irc{'stats'}->{'chans'}[0]) {
    @{$irc{'stats'}->{'chans'}} = (scalar keys %{$irc{'channel'}}, $ts);
    if ($cfg{'irc-connected'}) { &putinfo("x", "New max channel count: %d", $irc{'stats'}->{'chans'}[0]); }
  }

  return 0;
}

sub channel_mode {
  my ($nick, $chan, $mode, $args) = (shift, shift, shift, shift);
  my $what  = 1;
  my $idx   = 0;
  my $check = 0;
  my $author;
  my @arg; foreach (split(/ /, $args)) { push @arg, $_; }

  if (exists $irc{'client'}->{lc($nick)}) {
    $author = $irc{'client'}->{lc($nick)}->{'nick'} . "!" . $irc{'client'}->{lc($nick)}->{'user'} . "\@" . $irc{'client'}->{lc($nick)}->{'host'};
  } elsif (exists $irc{'server'}->{lc($nick)}) {
    $author = $irc{'server'}->{lc($nick)}->{'name'};
  }

  foreach (split(//, $mode)) {
    if ($_ eq "+") {
      $what = 1;
    } elsif ($_ eq "-") {
      $what = 0;
    } else {
      if (($_ eq "o") || ($_ eq "h") || ($_ eq "v")) {
        foreach my $bot (keys %services) {
          if (lc($services{$bot}->{'nick'}) eq lc($arg[$idx])) { $check = 1; }
        }

        if ($what) {
          $irc{'channel'}->{lc($chan)}->{'names'}->{lc($arg[$idx])}->{'mode'} |= $flags{'channel'}->{$_};
        } else {
          $irc{'channel'}->{lc($chan)}->{'names'}->{lc($arg[$idx])}->{'mode'} &= ~$flags{'channel'}->{$_};
        }
        ++$idx;
      } elsif ($_ eq "b") {
        if ($what) {
          @{$irc{'channel'}->{lc($chan)}->{'banlist'}->{lc($arg[$idx])}} = ($arg[$idx], $author, $ts);
        } else {
          if (exists $irc{'channel'}->{lc($chan)}->{'banlist'} && exists $irc{'channel'}->{lc($chan)}->{'banlist'}->{lc($arg[$idx])}) { delete $irc{'channel'}->{lc($chan)}->{'banlist'}->{lc($arg[$idx])}; }
        }
        ++$idx;
      } elsif ($_ eq "d") {
        if ($what) {
          @{$irc{'channel'}->{lc($chan)}->{'geclist'}->{lc($arg[$idx])}} = ($arg[$idx], $author, $ts);
        } else {
          if (exists $irc{'channel'}->{lc($chan)}->{'geclist'} && exists $irc{'channel'}->{lc($chan)}->{'geclist'}->{lc($arg[$idx])}) { delete $irc{'channel'}->{lc($chan)}->{'geclist'}->{lc($arg[$idx])}; }
        }
        ++$idx;
      } elsif ($_ eq "e") {
        if ($what) {
          @{$irc{'channel'}->{lc($chan)}->{'exclist'}->{lc($arg[$idx])}} = ($arg[$idx], $author, $ts);
        } else {
          if (exists $irc{'channel'}->{lc($chan)}->{'exclist'} && exists $irc{'channel'}->{lc($chan)}->{'exclist'}->{lc($arg[$idx])}) { delete $irc{'channel'}->{lc($chan)}->{'exclist'}->{lc($arg[$idx])}; }
        }
        ++$idx;
      } elsif (($_ =~ /[fIkl]/) && !(($_ eq "l") && !$what)) {
        if ($_ =~ /[kl]/) {
          if ($what) {
            $irc{'channel'}->{lc($chan)}->{'mode'} |= $flags{'channel'}->{$_};
          } else {
            $irc{'channel'}->{lc($chan)}->{'mode'} &= ~$flags{'channel'}->{$_};
          }
        }
        ++$idx;
      } else {
        if ($_ =~ /[acilmnpst]/) {
          if ($what) {
            $irc{'channel'}->{lc($chan)}->{'mode'} |= $flags{'channel'}->{$_};
          } else {
            $irc{'channel'}->{lc($chan)}->{'mode'} &= ~$flags{'channel'}->{$_};
          }
        }
      }
    }
  }

  if ($check) {
    foreach (keys %services) {
      my $bot = $services{$_}->{'nick'};

      if (exists $services{$_}->{'channel'} && exists $services{$_}->{'channel'}->{lc($chan)}) {
        if ((($services{$_}->{'channel'}->{lc($chan)}->{'mode'} eq "o") && !($irc{'channel'}->{lc($chan)}->{'names'}->{lc($bot)}->{'mode'} & $flags{'channel'}->{'o'})) ||
            (($services{$_}->{'channel'}->{lc($chan)}->{'mode'} eq "h") && !($irc{'channel'}->{lc($chan)}->{'names'}->{lc($bot)}->{'mode'} & $flags{'channel'}->{'h'})) ||
            (($services{$_}->{'channel'}->{lc($chan)}->{'mode'} eq "v") && !($irc{'channel'}->{lc($chan)}->{'names'}->{lc($bot)}->{'mode'} & $flags{'channel'}->{'v'}))) {
          &serv_part($bot, $irc{'channel'}->{lc($chan)}->{'channel'});
          &serv_join($bot, $irc{'channel'}->{lc($chan)}->{'channel'});
          &putinfo("y", "%s: %s attempted to change %s's mode", $irc{'channel'}->{lc($chan)}->{'channel'}, $author, $bot);
        }
      }
    }
  }

  return 0;
}

sub serv_part {
  my ($bot, $chan) = (shift, shift);
  my $nick = $services{$bot}->{'nick'};

  &putsock($sock{'irc'}, ":%s PART %s", $bot, $irc{'channel'}->{lc($chan)}->{'channel'});
  delete $irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)};
  if (scalar keys %{$irc{'channel'}->{lc($chan)}->{'names'}} == 0) { delete $irc{'channel'}->{lc($chan)}; }
  return 0;
}

sub serv_join {
  my ($bot, $chan) = (shift, shift);
  my $nick = $services{$bot}->{'nick'};
  my $chan_ts = $ts;
  my $chan_mode;
  my $mode;

  if (exists $irc{'channel'}->{lc($chan)}) {
    $chan_ts = $irc{'channel'}->{lc($chan)}->{'time'};
  } else {
    $irc{'channel'}->{lc($chan)}->{'channel'}  = $chan;
    $irc{'channel'}->{lc($chan)}->{'time'}     = $ts;
    @{$irc{'channel'}->{lc($chan)}->{'max'}}   = (1, $ts);
    @{$irc{'channel'}->{lc($chan)}->{'topic'}} = (undef, undef, 0);
    $irc{'channel'}->{lc($chan)}->{'mode'} |= $flags{'channel'}->{'n'};
    $irc{'channel'}->{lc($chan)}->{'mode'} |= $flags{'channel'}->{'t'};
    $chan_mode = "nt";
  }

  $irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)}->{'nick'} = $nick;
  $irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)}->{'mode'} = '';

  if ($services{$bot}->{'channel'}->{lc($chan)}->{'mode'} eq "o") {
    $irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)}->{'mode'} |= $flags{'channel'}->{'o'};
    $mode = "\@";
  } elsif ($services{$bot}->{'channel'}->{lc($chan)}->{'mode'} eq "h") {
    $irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)}->{'mode'} |= $flags{'channel'}->{'h'};
    $mode = "\%";
  } elsif ($services{$bot}->{'channel'}->{lc($chan)}->{'mode'} eq "v") {
    $irc{'channel'}->{lc($chan)}->{'names'}->{lc($nick)}->{'mode'} |= $flags{'channel'}->{'v'};
    $mode = "+";
  }

  &putsock($sock{'irc'}, ":%s SJOIN %d %s +%s :%s%s", $cfg{'irc-fakeserv'}, $chan_ts, $irc{'channel'}->{lc($chan)}->{'channel'}, $chan_mode, $mode, $nick);

  &channel_stats($chan);
  return 0;
}

sub process_channel {
  my ($nick, $chan, $query) = (shift, shift, shift);
  my $arg = (split(/ /, $query, 2))[1];

  if (exists $services{'DataServ'}->{'channel'} && exists $services{'DataServ'}->{'channel'}->{lc($chan)}) {
    if ($query =~ /^!(seen|whowas)/i) {
      &dataserv_seen($nick, $arg);
    } elsif ($query =~ /^!map/i) {
      &dataserv_map($nick, $arg);
    } elsif ($query =~ /^!(op|deop|halfop|dehalfop|voice|devoice|kick|ban|bankick|mode)/i) {
      &dataserv_chanquery($nick, $chan, $query);
    }
  }

  if (exists $services{'FindServ'} && exists $services{'FindServ'}->{'channel'} && exists $services{'FindServ'}->{'channel'}->{lc($chan)}) {
    if ($query =~ /^!alltheweb/i) {
      &findserv_alltheweb($nick, $arg);
    } elsif ($query =~ /^!altavista/i) {
      &findserv_altavista($nick, $arg);
    } elsif ($query =~ /^!cnet/i) {
      &findserv_cnet($nick, $arg);
    } elsif ($query =~ /^!freshmeat/i) {
      &findserv_freshmeat($nick, $arg);
    } elsif ($query =~ /^!google/i) {
      &findserv_google($nick, $arg);
    } elsif ($query =~ /^!linuxdoc/i) {
      &findserv_linuxdoc($nick, $arg);
    } elsif ($query =~ /^!lycos/i) {
      &findserv_lycos($nick, $arg);
    } elsif ($query =~ /^!slashdot/i) {
      &findserv_slashdot($nick, $arg);
    } elsif ($query =~ /^!yahoo/i) {
      &findserv_yahoo($nick, $arg);
    } elsif ($query =~ /^!whois/i) {
      &findserv_whois($nick, $arg);
    } elsif ($query =~ /^!(dns|nslookup)/i) {
      &findserv_nslookup($nick, $arg);
    }
  }

  if (exists $services{'FileServ'} && exists $services{'FileServ'}->{'channel'} && exists $services{'FileServ'}->{'channel'}->{lc($chan)}) {
    if (lc($query) eq "!start") {
      &fileserv_start($nick);
    } elsif (lc($query) eq "!status") {
      &fileserv_status($nick);
    }
  }

  return 0;
}

1;