# FXserv IRC services, Copyright (c) 2002 Christian Vandaele
# This program comes with absolutely NO WARRANTY
#
# Should you choose to use and/or modify this source code, please
# do so under the terms of the GNU General Public License under which
# this program is distributed.
#
# $Id: icq.pl

use strict;

if ($] < 5.006) {
  use vars qw(%cfg %im %services %sock $ts);
} else {
  our (%cfg, %im, %services, %sock, $ts);
}

my %icq_status = (
  'Available'      => 0x00020000,
  'Free For Chat'  => 0x00020020,
  'Away'           => 0x00020001,
  'N/A'            => 0x00020005,
  'Occupied'       => 0x00020011,
  'Do not Disturb' => 0x00020013,
  'Invisible'      => 0x00020100
);

my %icq_snac = (
  '1:3' => sub {
    my $output;

    @{$output->{'data'}} = &icq_snac_header(1, 0x17, 0, 0, 0x17);
    push @{$output->{'data'}}, (0, 1, 0, 3, 0, 2, 0, 1, 0, 3, 0, 1, 0, 21, 0, 1, 0, 4, 0, 1, 0, 6, 0, 1, 0, 9, 0, 1, 0, 10, 0, 1);
    &icq_output($sock{'icq'}, $output);
    return 0;
  },

  '1:24' => sub {
    my $output;

    @{$output->{'data'}} = &icq_snac_header(1, 6, 0, 0, 6);
    &icq_output($sock{'icq'}, $output);
    return 0;
  },

  '1:7' => sub {
    my $output;

    @{$output->{'data'}} = &icq_snac_header(1, 8, 0, 0, 0);
    push @{$output->{'data'}}, (0, 1, 0, 2, 0, 3, 0, 4, 0, 5);
    &icq_output($sock{'icq'}, $output);

    @{$output->{'data'}} = &icq_snac_header(1, 14, 0, 0, 0);
    &icq_output($sock{'icq'}, $output);

    @{$output->{'data'}} = &icq_snac_header(2, 2, 0, 0, 0);
    &icq_output($sock{'icq'}, $output);

    @{$output->{'data'}} = &icq_snac_header(3, 2, 0, 0, 0);
    &icq_output($sock{'icq'}, $output);

    @{$output->{'data'}} = &icq_snac_header(4, 4, 0, 0, 0);
    &icq_output($sock{'icq'}, $output);

    @{$output->{'data'}} = &icq_snac_header(9, 2, 0, 0, 0);
    &icq_output($sock{'icq'}, $output);
    return 0;
  },

  '1:15' => sub {
    return 0;
  },

  '2:3' => sub {
    return 0;
  },

  '3:3' => sub {
    return 0;
  },

  '4:5' => sub {
    return 0;
  },

  '9:3' => sub {
    my $output;

    @{$output->{'data'}} = &icq_snac_header(4, 2, 0, 0, 0);
    push @{$output->{'data'}}, (0, 0, 0, 0, 0, 3, 0x1F, 0x40, 3, 0xE7, 3, 0xEF, 0, 0, 0, 0);
    &icq_output($sock{'icq'}, $output);

    @{$output->{'data'}} = &icq_snac_header(2, 4, 0, 0, 0);
    push @{$output->{'data'}}, &int2bytes(2, 5);
    push @{$output->{'data'}}, &int2bytes(2, 32);
    foreach ("09", "46", "13", "49", "4C", "7F", "11", "D1", "82", "22", "44", "45", "53", "54", "00", "00", "09", "46", "13", "44", "4C", "7F", "11", "D1", "82", "22", "44", "45", "53", "54", "00", "00") { push @{$output->{'data'}}, ord($_); }
    &icq_output($sock{'icq'}, $output);

    if (scalar @{$im{'data'}->{'icq'}->{'list'}}) {
      @{$output->{'data'}} = &icq_snac_header(3, 4, 0, 0, 4);
      for (my $sub = 0; $sub < scalar @{$im{'data'}->{'icq'}->{'list'}}; $sub++) {
        push @{$output->{'data'}}, &int2bytes(1, length($im{'data'}->{'icq'}->{'list'}[$sub][0]));
        push @{$output->{'data'}}, &str2bytes($im{'data'}->{'icq'}->{'list'}[$sub][0]);
      }
      &icq_output($sock{'icq'}, $output);
    }

    @{$output->{'data'}} = &icq_snac_header(1, 30, 0, 0, 0);
    push @{$output->{'data'}}, &icq_write_tlv(2, 'TLV06', 0x00020000);
    &icq_output($sock{'icq'}, $output);

    @{$output->{'data'}} = &icq_snac_header(1, 17, 0, 0, 0);
    push @{$output->{'data'}}, &int2bytes(4, 0);
    &icq_output($sock{'icq'}, $output);

    @{$output->{'data'}} = &icq_snac_header(1, 2, 0, 0, 0);
    push @{$output->{'data'}}, &int2bytes(2, 1);
    push @{$output->{'data'}}, &int2bytes(2, 3);
    push @{$output->{'data'}}, &int2bytes(2, 0x0110);
    push @{$output->{'data'}}, &int2bytes(2, 0x028A);
    push @{$output->{'data'}}, &int2bytes(2, 2);
    push @{$output->{'data'}}, &int2bytes(2, 1);
    push @{$output->{'data'}}, &int2bytes(2, 0x0101);
    push @{$output->{'data'}}, &int2bytes(2, 0x028A);
    push @{$output->{'data'}}, &int2bytes(2, 3);
    push @{$output->{'data'}}, &int2bytes(2, 1);
    push @{$output->{'data'}}, &int2bytes(2, 0x0110);
    push @{$output->{'data'}}, &int2bytes(2, 0x028A);
    push @{$output->{'data'}}, &int2bytes(2, 0x15);
    push @{$output->{'data'}}, &int2bytes(2, 1);
    push @{$output->{'data'}}, &int2bytes(2, 0x0110);
    push @{$output->{'data'}}, &int2bytes(2, 0x028A);
    push @{$output->{'data'}}, &int2bytes(2, 4);
    push @{$output->{'data'}}, &int2bytes(2, 1);
    push @{$output->{'data'}}, &int2bytes(2, 0x0110);
    push @{$output->{'data'}}, &int2bytes(2, 0x028A);
    push @{$output->{'data'}}, &int2bytes(2, 6);
    push @{$output->{'data'}}, &int2bytes(2, 1);
    push @{$output->{'data'}}, &int2bytes(2, 0x0110);
    push @{$output->{'data'}}, &int2bytes(2, 0x028A);
    push @{$output->{'data'}}, &int2bytes(2, 9);
    push @{$output->{'data'}}, &int2bytes(2, 1);
    push @{$output->{'data'}}, &int2bytes(2, 0x0110);
    push @{$output->{'data'}}, &int2bytes(2, 0x028A);
    push @{$output->{'data'}}, &int2bytes(2, 0x0A);
    push @{$output->{'data'}}, &int2bytes(2, 1);
    push @{$output->{'data'}}, &int2bytes(2, 0x0110);
    push @{$output->{'data'}}, &int2bytes(2, 0x028A);
    &icq_output($sock{'icq'}, $output);

    &icq_send_cmd(undef, undef, undef);
    #&icq_send_cmd("key", "DataFilesIP", undef);
    #&icq_send_cmd("key", "BannersIP", undef);
    #&icq_send_cmd("key", "ChannelsIP", undef);

    return 0;
  },

  '21:3' => sub {
    my $incoming = shift;
    my $idx = 16;
    my $length;
    my $recv;
    my $uin;

    $recv->{'flags'} = &bytes2int($incoming->{'data'}, 4, 2);
    $recv->{'ref'}   = &bytes2int($incoming->{'data'}, 6, 4);

    if (exists $im{'data'}->{'icq'}->{'request'}->{$recv->{'ref'}}) {
      $recv->{'response'} = $im{'data'}->{'icq'}->{'request'}->{$recv->{'ref'}};
      delete $im{'data'}->{'icq'}->{'request'}->{$recv->{'ref'}};
    }

    $idx += 4;

    $recv->{'msgcmd'} = &endian2int($incoming->{'data'}, $idx, 2);
    $idx += 2;

    if ($recv->{'msgcmd'} == 66) {
      &icq_send_cmd("ack_offline", undef, undef);
    } elsif ($recv->{'msgcmd'} == 2010) {
      $idx += 2;
      $idx += 5;

      $uin = &endian2int($incoming->{'data'}, $idx, 4);
      $im{'icq'}->{$uin}->{'uin'} = $uin;
      $idx += 4;

      $length = &endian2int($incoming->{'data'}, $idx, 2);

      $im{'icq'}->{$uin}->{'nick'} = &bytes2str($incoming->{'data'}, $idx + 2, $length - 1);
      if ($im{'icq'}->{$uin}->{'nick'} eq "") { $im{'icq'}->{$uin}->{'nick'} = $uin; }

      for (my $sub = 0; $sub < scalar @{$im{'data'}->{'icq'}->{'list'}}; $sub++) {
        if (($im{'data'}->{'icq'}->{'list'}[$sub][0] eq $uin) && ($im{'data'}->{'icq'}->{'list'}[$sub][1] ne "")) {
          $im{'icq'}->{$uin}->{'nick'} = $im{'data'}->{'icq'}->{'list'}[$sub][1]; last;
        }
      }

      $idx += $length + 2;

      $length = &endian2int($incoming->{'data'}, $idx, 2);
      $im{'icq'}->{$uin}->{'first'} = &bytes2str($incoming->{'data'}, $idx + 2, $length - 1);
      $idx += $length + 2;

      $length = &endian2int($incoming->{'data'}, $idx, 2);
      $im{'icq'}->{$uin}->{'last'} = &bytes2str($incoming->{'data'}, $idx + 2, $length - 1);
      $idx += $length + 2;

      $length = &endian2int($incoming->{'data'}, $idx, 2);
      $im{'icq'}->{$uin}->{'email'} = &bytes2str($incoming->{'data'}, $idx + 2, $length - 1);
      $idx += $length + 2;

      foreach (keys %{$im{'request'}}) {
        if (($im{'request'}->{$_}->{'type'} eq "ICQ") && ($uin eq $im{'request'}->{$_}->{'uin'})) {
          # putsock infos
          delete $im{'request'}->{$_};
        }
      }

      if (scalar @{$im{'data'}->{'icq'}->{'list'}}) {
        for (my $sub = 0; $sub < scalar @{$im{'data'}->{'icq'}->{'list'}}; $sub++) {
          if ($uin eq $im{'data'}->{'icq'}->{'list'}[$sub][0]) { &icq_adduser($uin); last; }
        }
      }
    }

    return 0;
  },

  '3:11' => sub {
    my $incoming = shift;
    my $idx      = 10;
    my $length   = ${$incoming->{'data'}}[$idx++];
    my $user;

    $user->{'uin'} = &bytes2str($incoming->{'data'}, $idx, $length);

    if (!exists $im{'icq'}->{$user->{'uin'}}) {
      $idx += $length + 4;
      $user = &icq_read_tlv($incoming->{'data'}, 2, $idx, $user, &bytes2int($incoming->{'data'}, $idx - 4, 4));

      my $addr = pack("C4", split(/\./, $user->{'ip'}));
      my $host = gethostbyaddr($addr, &AF_INET);

      $im{'icq'}->{$user->{'uin'}}->{'uin'}  = $user->{'uin'};
      $im{'icq'}->{$user->{'uin'}}->{'ip'}   = $user->{'ip'};
      $im{'icq'}->{$user->{'uin'}}->{'host'} = $host ? $host : $user->{'ip'};
      $im{'icq'}->{$user->{'uin'}}->{'signon'} = $user->{'signon'};
      $im{'icq'}->{$user->{'uin'}}->{'signup'} = $user->{'signup'};

      &icq_send_cmd("meta", "searchbyuin", $user->{'uin'});
    }

    return 0;
  },

  '3:12' => sub {
    my $incoming = shift;

    my $uin = &bytes2str($incoming->{'data'}, 11, ${$incoming->{'data'}}[10]);
    &icq_killuser($uin, "Signed off");
    return 0;
  },

  '4:7' => sub {
    my $incoming = shift;
    my $idx = 19;
    my $recv;

    $recv->{'sendertype'} = $incoming->{'data'}->[$idx++];
    my $length = ${$incoming->{'data'}}[$idx++];

    $recv->{'sender'} = &bytes2str($incoming->{'data'}, $idx, $length);
    $idx += $length + 4;

    $recv = &icq_read_tlv($incoming->{'data'}, 2, $idx, $recv, &bytes2int($incoming->{'data'}, $idx - 4, 4));
    return 0;
  }

);

my %icq_tlv_in = (
  2 => {
    'signup'    => 0x02,
    'signon'    => 0x03,
    'status'    => 0x06,
    'ip'        => 0x0A,
    'html_addr' => 0x0B,
  },

  4 => {
    'TLV01' => 0x01, # UIN
    'TLV04' => 0x04, # url
    'TLV05' => 0x05, # server:port
    'TLV06' => 0x06, # cookie
    'TLV08' => 0x08, # error code
    'TLV09' => 0x09, # bad password
    'TLV0C' => 0x0C  # unknown
  }
);

my %icq_tlv_out = (
  1 => {
    'TLV01' => 0x01, # UIN
    'TLV02' => 0x02, # encoded password
    'TLV03' => 0x03, # client profile
    'TLV06' => 0x06, # cookie
    'TLV0E' => 0x0E, # country
    'TLV0F' => 0x0F, # language
    'TLV14' => 0x14, # dunno version
    'TLV16' => 0x16, # unknown
    'TLV17' => 0x17, # major version
    'TLV18' => 0x18, # minor version
    'TLV19' => 0x19, # lesser version
    'TLV1A' => 0x1A  # build version
  },

  2 => {
    'TLV06' => 0x06,
    'TLV08' => 0x08,
    'TLV0C' => 0x0C
  }
);

my %icq_tlv_len_out = (
  1 => {
    'TLV06' => 1000,
    'TLV14' => 4,
    'TLV16' => 2,
    'TLV17' => 2,
    'TLV18' => 2,
    'TLV19' => 2,
    'TLV1A' => 2,
    'TLV1B' => 2,
    'TLV1C' => 2,
    'TLV1D' => 2,
    'TLV1E' => 2,
    'TLV1F' => 2
  },

  2 => {
    'TLV06' => 4,
    'TLV08' => 2
  }
);

my %icq_tlv_len_in = (
  2 => {
    1  => 1,
    2  => 1,
    3  => 1,
    4  => 1,
    5  => 2,
    6  => 1,
    10 => 3,
    15 => 1
  },

  4 => {
    8 => 1,
    6 => 2
  }
);

sub connect2icq {
  my $reconnect = shift;
  $cfg{'icq-attempt'} = $ts;

  if (!$reconnect) {
    $im{'data'}->{'icq'}->{'server'}    = "login.icq.com";
    $im{'data'}->{'icq'}->{'port'}      = 5190;
    $im{'data'}->{'icq'}->{'seqnum'}    = int(rand(0xFFFF));
    $im{'data'}->{'icq'}->{'flapbytes'} = 0;
    $im{'data'}->{'icq'}->{'flaprecv'}  = undef;
    $im{'data'}->{'icq'}->{'cookie'}    = '';
    $im{'data'}->{'icq'}->{'mem'}       = 1;
    $im{'data'}->{'icq'}->{'request'}   = undef;
  }

  my $socket = IO::Socket::INET->new(
    Proto    => "tcp",
    PeerAddr => $im{'data'}->{'icq'}->{'server'},
    PeerPort => $im{'data'}->{'icq'}->{'port'},
    Timeout  => 3
  );

  if (!$socket) {
    &putinfo("y", "Unable to connect to ICQ server %s:%d", $im{'data'}->{'icq'}->{'server'}, $im{'data'}->{'icq'}->{'port'});
    return 0;
  }

  $socket->autoflush(1);

  $sock{'icq'} = $socket;
  $sock{'list'}->{$socket}->{'sock'}   = $socket;
  $sock{'list'}->{$socket}->{'type'}   = "ICQ";
  $sock{'list'}->{$socket}->{'host'}   = $socket->peerhost();
  $sock{'list'}->{$socket}->{'port'}   = $socket->peerport();
  $sock{'list'}->{$socket}->{'fileno'} = $socket->fileno();
  vec($bit, $sock{'list'}->{$socket}->{'fileno'}, 1) = 1;

  return 0;
}

sub icq_send_cmd {
  my ($type, $key, $text) = (shift, shift, shift);
  my $output;
  my @packet;

  @{$output->{'data'}} = &icq_snac_header(0x15, 2, 0, 0, ($im{'data'}->{'icq'}->{'mem'}++ * 65536 + 0x02));
  push @{$output->{'data'}}, &int2bytes(2, 1);
  push @packet, &int2endian(4, $cfg{'icq-uin'});

  if (!$type) {
    push @packet, &int2bytes(2, 0x3C00);
    push @packet, &int2bytes(1, $im{'data'}->{'icq'}->{'mem'});
    push @packet, &int2bytes(1, 0);
  } elsif ($type eq "meta") {
    if ($key eq "searchbyuin") {
      push @packet, &int2bytes(2, 0xD007);
      push @packet, &int2bytes(1, $im{'data'}->{'icq'}->{'mem'});
      push @packet, &int2bytes(1, 0);
      push @packet, &int2bytes(4, 0x69053601);
      push @packet, &int2endian(2, 4);
      push @packet, &int2endian(4, $text);
    }
  } elsif ($type eq "ack_offline") {
    push @packet, &int2bytes(2, 0x3E00);
    push @packet, &int2bytes(1, $im{'data'}->{'icq'}->{'mem'});
    push @packet, &int2bytes(1, 0);
  } elsif ($type eq "key") {
    my $xmlkey = "<key>" . $key . "</key>";
    $im{'data'}->{'icq'}->{'request'}->{(($im{'data'}->{'icq'}->{'mem'} - 1) * 65536 + 0x02)} = $key;

    push @packet, &int2bytes(2, 0xD007);
    push @packet, &int2bytes(1, $im{'data'}->{'icq'}->{'mem'});
    push @packet, &int2bytes(3, 0x9808);
    push @packet, &int2endian(2, length($xmlkey) + 1);
    push @packet, &str2bytes($xmlkey);
    push @packet, &int2bytes(1, 0);
  }

  push @{$output->{'data'}}, &int2bytes(2, scalar @packet + 2);
  push @{$output->{'data'}}, &int2endian(2, scalar @packet);
  push @{$output->{'data'}}, @packet;
  &icq_output($sock{'icq'}, $output);

  return 0;
}

sub icq_snac_header {
  my($family, $sub_family, $flag_a, $flag_b, $request_id) = (shift, shift, shift, shift, shift);
  my @header;

  @header = &int2bytes(2, $family);
  push @header, &int2bytes(2, $sub_family);
  push @header, &int2bytes(1, $flag_a);
  push @header, &int2bytes(1, $flag_b);
  push @header, &int2bytes(4, $request_id);

  return @header;
}

sub icq_read_tlv {
  my ($array, $chan_id, $start, $recv, $max) = (shift, shift, shift, shift, shift);
  my ($data_type, $data_len, $data_name);
  my $idx = 0;

  if (!$start) { $start = 0; }
  if (!$max) { $max = 100000; }

  for ($idx = $start; $idx < @$array;) {
    if (--$max < 0) { last };

    $data_type = &bytes2int($array, $idx, 2);
    $data_len  = &bytes2int($array, $idx + 2, 2);
    $idx += 4;

    $data_name = $data_type;
    foreach (keys %{$icq_tlv_in{$chan_id}}) {
      if ($icq_tlv_in{$chan_id}->{$_} == $data_type) { $data_name = $_; }
    }

    if ($icq_tlv_len_in{$chan_id}->{$data_type} == 2) {
      for (my $ptr = 0; $ptr < $data_len; $ptr++) { $recv->{$data_name} .= $array->[$idx + $ptr] . " "; }
      $recv->{$data_name} =~ s/\s+$//;
    } elsif ($icq_tlv_len_in{$chan_id}->{$data_type} == 3) {
      if ($data_len == 4) { $recv->{$data_name} = &bytes2int($array, $idx, 1) . "." . &bytes2int($array, $idx + 1, 1) . "." . &bytes2int($array, $idx + 2, 1) . "." . &bytes2int($array, $idx + 3, 1); }
    } elsif ($icq_tlv_len_in{$chan_id}->{$data_type} == 1) {
      $recv->{$data_name} = &bytes2int($array, $idx, $data_len);
    } else {
      $recv->{$data_name} = &bytes2str($array, $idx, $data_len);
    }

    $idx += $data_len;
  }

  return $recv;
}

sub icq_write_tlv {
  my ($chan_id, $tlv, $send) = (shift, shift, shift);
  my @data;

  @data = &int2bytes(2, $icq_tlv_out{$chan_id}->{$tlv});

  if ($icq_tlv_len_out{$chan_id}->{$tlv} == 1000) {
    my @cookie = split(/ /, $send);
    push @data, &int2bytes(2, scalar @cookie);
    push @data, @cookie;
  } elsif (exists $icq_tlv_len_out{$chan_id}->{$tlv}) {
    push @data, &int2bytes(2, $icq_tlv_len_out{$chan_id}->{$tlv});
    push @data, &int2bytes($icq_tlv_len_out{$chan_id}->{$tlv}, $send);
  } else {
    push @data, &int2bytes(2, length($send));
    push @data, &str2bytes($send);
  }

  return @data;
}

sub icq_uin2buin {
  my $uin = shift;
  my @result;

  push @result, length($uin);

  foreach (split(//, $uin ? $uin : '')) { push @result, ord($_); }
  return @result;
}

sub icq_passwd {
  my $passwd = shift;
  my $result;
  my @table;

  my @enc_table = (0xF3, 0x26, 0x81, 0xC4, 0x39, 0x86, 0xDB, 0x92, 0x71, 0xA3, 0xB9, 0xE6, 0x53, 0x7A, 0x95, 0x7C);

  foreach (split (//, $passwd)) { push @table, ord($_); }
  for (my $idx = 0; $idx < length($passwd); $idx++) { $result .= chr($table[$idx] ^ $enc_table[$idx]); }

  return $result;
}

sub icq_incoming {
  my $incoming = shift;
  my $output;

  if ($incoming->{'chan_id'} == 1) {
    $output->{'chan_id'} = 1;

    if ($im{'data'}->{'icq'}->{'cookie'}) {
      @{$output->{'data'}} = &int2bytes(4, 1);
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV06", $im{'data'}->{'icq'}->{'cookie'});
      &icq_output($sock{'icq'}, $output);
      $im{'data'}->{'icq'}->{'cookie'} = 0;
      &putinfo("y", "Connected to ICQ server %s:%d", $im{'data'}->{'icq'}->{'server'}, $im{'data'}->{'icq'}->{'port'});
    } else {
      @{$output->{'data'}} = &int2bytes(2, 0);
      push @{$output->{'data'}}, &int2bytes(2, 1);
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV01", $cfg{'icq-uin'});
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV02", &icq_passwd($cfg{'icq-passwd'}));
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV03", "ICQ Inc. - Product of ICQ (TM).2001b.5.15.1.3638.85");
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV16", 266);
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV17", 5);
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV18", 15);
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV19", 1);
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV1A", 3638);
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV14", 85);
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV0F", "en");
      push @{$output->{'data'}}, &icq_write_tlv(1, "TLV0E", "us");
      &icq_output($sock{'icq'}, $output);
    }

  } elsif ($incoming->{'chan_id'} == 2) {
    my $id = $incoming->{'family_id'} . ":" . $incoming->{'sub_id'};

    if (exists $icq_snac{$id}) { &{$icq_snac{$id}}($incoming); }

  } elsif ($incoming->{'chan_id'} == 4) {
    my $recv = &icq_read_tlv($incoming->{'data'}, 4);

    if ($recv->{'TLV06'}) { $im{'data'}->{'icq'}->{'cookie'} = $recv->{'TLV06'}; }

    if ($recv->{'TLV05'}) {
      $output->{'chan_id'} = 4;
      @{$output->{'data'}} = ();
      &icq_output($sock{'icq'}, $output);

      &del_socket($sock{'icq'});
      $im{'data'}->{'icq'}->{'server'} = (split(/:/, $recv->{'TLV05'}, 0))[0];
      $im{'data'}->{'icq'}->{'port'}   = (split(/:/, $recv->{'TLV05'}, 0))[1];

      &connect2icq(1);
    } elsif ($recv->{'TLV08'} || $recv->{'TLV09'}) {
      &putinfo("y", "ICQ error, disconnecting");
      &del_socket($sock{'icq'});
    }
  }

  return 0;
}

sub icq_output {
  my ($socket, $output) = (shift, shift);
  my $chan_id = 2;
  my $raw;
  my @header;

  if ($output->{'chan_id'}) { $chan_id = $output->{'chan_id'}; }

  @header = (42, $chan_id);

  if (++$im{'data'}->{'icq'}->{'seqnum'} > 65535) { $im{'data'}->{'icq'}->{'seqnum'} = 0; }

  push @header, &int2bytes(2, $im{'data'}->{'icq'}->{'seqnum'});
  push @header, &int2bytes(2, scalar @{$output->{'data'}});

  foreach (@header) { $raw .= chr($_); }
  foreach (@{$output->{'data'}}) { $raw .= chr($_); }

  if ($raw) { print $socket $raw; }
  return 0;
}

sub icq_newuser {
  my $uin = shift;
  my $output;

  @{$output->{'data'}} = &icq_snac_header(3, 4, 0, 0, 4);
  push @{$output->{'data'}}, &int2bytes(1, length($uin));
  push @{$output->{'data'}}, &str2bytes($uin);
  &icq_output($sock{'icq'}, $output);
  return 0;
}

sub icq_adduser {
  my $uin = shift;
  my $irc_nick = $cfg{'icq-nick'}; $irc_nick =~ s/\%/$im{'icq'}->{$uin}->{'nick'}/;
  my $real;

  foreach (keys %{$im{'icq'}}) {
    if ((lc($im{'icq'}->{$_}->{'irc'}) eq lc($irc_nick)) && ($uin != $_)) {
      $irc_nick = $cfg{'icq-nick'};
      $irc_nick =~ s/\%/$uin/;
    }
  }

  $im{'icq'}->{$uin}->{'irc'} = $irc_nick;

  $real = $im{'icq'}->{$uin}->{'first'} . " " . $im{'icq'}->{$uin}->{'last'};

  if ($cfg{'server-type'} eq "hybrid") {
    &putsock($sock{'irc'}, "NICK %s 1 %d %s %s %s %s :%s", $irc_nick, $ts, "+i", $uin, $im{'icq'}->{$uin}->{'host'}, $cfg{'irc-fakeserv'}, $real);
    &putsock($sock{'irc'}, ":%s MODE :%s", $irc_nick, "+i");
  } elsif ($cfg{'server-type'} eq "bahamut") {
    &putsock($sock{'irc'}, "NICK %s 1 %d %s %s %s %s 0 0 :%s", $irc_nick, $ts, "+i", $uin, $im{'icq'}->{$uin}->{'host'}, $cfg{'irc-fakeserv'}, $real);
  } elsif ($cfg{'server-type'} eq "ultimate") {
    &putsock($sock{'irc'}, "NICK %s 1 %d %s %s %s 0 :%s", $irc_nick, $ts, $uin, $im{'icq'}->{$uin}->{'host'}, $cfg{'irc-fakeserv'}, $real);
    &putsock($sock{'irc'}, "MODE %s %s", $irc_nick, "+i");
  }

  $irc{'client'}->{lc($irc_nick)}->{'nick'} = $irc_nick;
  $irc{'client'}->{lc($irc_nick)}->{'user'} = $uin;
  $irc{'client'}->{lc($irc_nick)}->{'host'} = $im{'icq'}->{$uin}->{'host'};
  $irc{'client'}->{lc($irc_nick)}->{'real'} = $real;
  $irc{'client'}->{lc($irc_nick)}->{'serv'} = $cfg{'irc-fakeserv'};
  $irc{'client'}->{lc($irc_nick)}->{'time'} = $ts;
  $irc{'client'}->{lc($irc_nick)}->{'mode'} |= $flags{'client'}->{'i'};

  &client_stats($irc_nick);

  if ($cfg{'icq-chan'}) {
    my $chan_ts = $ts;
    my $chan_mode;
    my $mode;

    if (exists $irc{'channel'}->{lc($cfg{'icq-chan'})}) {
      $chan_ts = $irc{'channel'}->{lc($cfg{'icq-chan'})}->{'time'};
    } else {
      $irc{'channel'}->{lc($cfg{'icq-chan'})}->{'channel'}  = $cfg{'icq-chan'};
      $irc{'channel'}->{lc($cfg{'icq-chan'})}->{'time'}     = $ts;
      @{$irc{'channel'}->{lc($cfg{'icq-chan'})}->{'max'}}   = (1, $ts);
      @{$irc{'channel'}->{lc($cfg{'icq-chan'})}->{'topic'}} = (undef, undef, 0);
      $irc{'channel'}->{lc($cfg{'icq-chan'})}->{'mode'} |= $flags{'channel'}->{'n'};
      $irc{'channel'}->{lc($cfg{'icq-chan'})}->{'mode'} |= $flags{'channel'}->{'t'};
      $chan_mode = "nt";
    }

    $irc{'channel'}->{lc($cfg{'icq-chan'})}->{'names'}->{lc($irc_nick)}->{'nick'} = $irc_nick;
    $irc{'channel'}->{lc($cfg{'icq-chan'})}->{'names'}->{lc($irc_nick)}->{'mode'} = '';
    &putsock($sock{'irc'}, ":%s SJOIN %d %s +%s :%s%s", $cfg{'irc-fakeserv'}, $chan_ts, $irc{'channel'}->{lc($cfg{'icq-chan'})}->{'channel'}, $chan_mode, $mode, $irc_nick);
    &channel_stats($cfg{'icq-chan'});
  }

  return 0;
}

sub icq_killuser {
  my ($uin, $reason) = (shift, shift);
  my $nick = $im{'icq'}->{$uin}->{'irc'};

  delete $im{'icq'}->{$uin};
  if (exists $irc{'client'}->{lc($nick)}) {
    &putsock($sock{'irc'}, ":%s QUIT :%s", $nick, $reason);
    &del_client($nick);
  }

  return 0;
}

sub icq_requser {
  my $uin = shift;
  my $output;

  @{$output->{'data'}} = &icq_snac_header(3, 5, 0, 0, 5);
  push @{$output->{'data'}}, &int2bytes(1, length($uin));
  push @{$output->{'data'}}, &str2bytes($uin);
  &icq_output($sock{'icq'}, $output);
  $output = undef;

  @{$output->{'data'}} = &icq_snac_header(3, 4, 0, 0, 4);
  push @{$output->{'data'}}, &int2bytes(1, length($uin));
  push @{$output->{'data'}}, &str2bytes($uin);
  &icq_output($sock{'icq'}, $output);

  return 0;
}

sub icq_eraseuser {
  my $uin = shift;

  &icq_killuser($uin, "Deleted");

  if ($sock{'icq'}) {
    my $output;

    @{$output->{'data'}} = &icq_snac_header(3, 5, 0, 0, 5);
    push @{$output->{'data'}}, &int2bytes(1, length($uin));
    push @{$output->{'data'}}, &str2bytes($uin);
    &icq_output($sock{'icq'}, $output);
  }

  return 0;
}

sub icq_msguser {
  my ($nick, $uin, $query) = (shift, shift, shift);

  if ($query =~ /\cA(.*)\cA/) {
    my $ctcp = uc((split(/ /, $1, 0))[0]);

    if ($ctcp eq "VERSION") {
      &putsock($sock{'irc'}, ":%s NOTICE %s :\cAVERSION %s\cA", $im{'icq'}->{$uin}->{'irc'}, $nick, "FXserv IRC services $VERSION");
    } elsif ($ctcp eq "PING") {
      &putsock($sock{'irc'}, ":%s NOTICE %s :\cAPING %s\cA", $im{'icq'}->{$uin}->{'irc'}, $nick, (split(/ /, $1, 0))[1]);
    } elsif ($ctcp eq "TIME") {
      &putsock($sock{'irc'}, ":%s NOTICE %s :\cATIME %s\cA", $im{'icq'}->{$uin}->{'irc'}, $nick, scalar localtime());
    } elsif ($ctcp eq "DCC") {
    }

    return 0;
  }

  $query = "<" . $nick . "> " . $query;

  my $length = length($query) + 4;
  my $output;
  my @packet;

  @{$output->{'data'}} = &icq_snac_header(4, 6, 0, 1, 6);

  push @packet, &int2bytes(4, int(rand(0xFFFFFFFF)));
  push @packet, &int2bytes(4, int(rand(0xFFFFFFFF)));
  push @packet, &int2bytes(2, 0x0001);
  push @packet, &icq_uin2buin($uin);
  push @packet, &int2bytes(2, 0x0002);
  push @packet, &int2bytes(2, $length + 9);
  push @packet, &int2bytes(3, 0x050100);
  push @packet, &int2bytes(4, 0x01010101);
  push @packet, &int2bytes(2, $length);
  push @packet, &int2bytes(2, 0);
  push @packet, &int2bytes(2, 0xFFFF);
  push @packet, &str2bytes($query);
  push @packet, &int2bytes(2, 0x0006);
  push @packet, &int2bytes(2, 0x0000);
  push @{$output->{'data'}}, @packet;
  &icq_output($sock{'icq'}, $output);

  return 0;
}

sub icq_newnick {
  my ($uin, $nick) = (shift, shift);

  if (exists $im{'icq'}->{$uin}) {
    my $newnick = $cfg{'icq-nick'}; $newnick =~ s/\%/$nick/;
    my $oldnick = $im{'icq'}->{$uin}->{'irc'};

    &putsock($sock{'irc'}, ":%s NICK %s", $oldnick, $newnick);

    $irc{'client'}->{lc($newnick)}->{'nick'} = $newnick;
    $irc{'client'}->{lc($newnick)}->{'user'} = $irc{'client'}->{lc($oldnick)}->{'user'};
    $irc{'client'}->{lc($newnick)}->{'host'} = $irc{'client'}->{lc($oldnick)}->{'host'};
    $irc{'client'}->{lc($newnick)}->{'real'} = $irc{'client'}->{lc($oldnick)}->{'real'};
    $irc{'client'}->{lc($newnick)}->{'serv'} = $irc{'client'}->{lc($oldnick)}->{'serv'};
    $irc{'client'}->{lc($newnick)}->{'time'} = $irc{'client'}->{lc($oldnick)}->{'time'};
    $irc{'client'}->{lc($newnick)}->{'mode'} = $irc{'client'}->{lc($oldnick)}->{'mode'};;
    delete $irc{'client'}->{lc($oldnick)};

    $im{'icq'}->{$uin}->{'nick'} = $nick;
    $im{'icq'}->{$uin}->{'irc'}  = $newnick;
    return 0;
  }

  return 0;
}

1;