# FXserv IRC services, Copyright (c) 2002 Christian Vandaele
# This program comes with absolutely NO WARRANTY
#
# Should you choose to use and/or modify this source code, please
# do so under the terms of the GNU General Public License under which
# this program is distributed.
#
# $Id: mysql.pl

use strict;
use DBI;

if ($] < 5.006) {
  use vars qw(%cfg %flags %irc $ts);
} else {
  our (%cfg, %flags, %irc, $ts);
}

sub save_mysql {
  my $sth;
  my $query;

  $cfg{'last-mysql'} = $ts;

  if (my $pid = fork) {
    my $dbs = sprintf("DBI:mysql:%s:%s:%d", $cfg{'mysql-database'}, (split(/:/, $cfg{'mysql-host'}, 0))[0], (split(/:/, $cfg{'mysql-host'}, 0))[1]); 
    my $dbh = DBI->connect($dbs, $cfg{'mysql-user'}, $cfg{'mysql-pass'});

    if (!$dbh) {
      &putinfo("y", "Can't connect to MySQL database %s", $dbs);
      exit(1);
    }

    $query = sprintf("INSERT INTO %s \(time, servers, maxservers, maxserverstime, users, maxusers, maxuserstime, opers, maxopers, maxoperstime, channels, maxchannels, maxchannelstime, operkills, serverkills\) VALUES \(\'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\'\)", $cfg{'mysql-tstats'}, $ts, scalar keys %{$irc{'server'}}, $irc{'stats'}->{'servs'}[0], $irc{'stats'}->{'servs'}[1], scalar keys %{$irc{'client'}}, $irc{'stats'}->{'users'}[0], $irc{'stats'}->{'users'}[1], $irc{'stats'}->{'opers'}[0], $irc{'stats'}->{'opers'}[1], $irc{'stats'}->{'opers'}[2], scalar keys %{$irc{'channel'}}, $irc{'stats'}->{'chans'}[0], $irc{'stats'}->{'chans'}[1], $irc{'stats'}->{'kills'}[0], $irc{'stats'}->{'kills'}[1]);
    $sth   = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    $query = sprintf("DELETE FROM %s", $cfg{'mysql-tserver'});
    $sth   = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    foreach (keys %{$irc{'server'}}) {
      $query = sprintf("INSERT INTO %s \(server, descr, hopcount, hub, uptime, users, maxusers, maxuserstime, opers, maxopers, maxoperstime\) VALUES \(\'%s\', \'%s\', \'%d\', \'%s\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\'\)", $cfg{'mysql-tserver'}, $irc{'server'}->{$_}->{'name'}, $irc{'server'}->{$_}->{'info'}, $irc{'server'}->{$_}->{'hopcount'}, $irc{'server'}->{$_}->{'hub'}, $irc{'server'}->{$_}->{'time'}, $irc{'server'}->{$_}->{'users'}[0], $irc{'server'}->{$_}->{'users'}[1], $irc{'server'}->{$_}->{'users'}[2], $irc{'server'}->{$_}->{'opers'}[0], $irc{'server'}->{$_}->{'opers'}[1], $irc{'server'}->{$_}->{'opers'}[2]);
      $sth   = $dbh->prepare($query);
      $sth->execute;
      $sth->finish;
    }

    $query = sprintf("DELETE FROM %s", $cfg{'mysql-ttld'});
    $sth   = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    foreach (keys %{$irc{'stats'}->{'tld'}}) {
      $query = sprintf("INSERT INTO %s \(tld, time, users, maxusers, maxuserstime\) VALUES \(\'%s\', \'%d\', \'%d\', \'%d\', \'%d\'\)", $cfg{'mysql-ttld'}, $_, $ts, $irc{'stats'}->{'tld'}->{$_}[0], $irc{'stats'}->{'tld'}->{$_}[1], $irc{'stats'}->{'tld'}->{$_}[2]);
      $sth   = $dbh->prepare($query);
      $sth->execute;
      $sth->finish;
    }

    $query = sprintf("DELETE FROM %s", $cfg{'mysql-tdomain'});
    $sth   = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    foreach (keys %{$irc{'stats'}->{'domain'}}) {
      $query = sprintf("INSERT INTO %s \(domain, time, users, maxusers, maxuserstime\) VALUES \(\'%s\', \'%d\', \'%d\', \'%d\', \'%d\'\)", $cfg{'mysql-tdomain'}, $_, $ts, $irc{'stats'}->{'domain'}->{$_}[0], $irc{'stats'}->{'domain'}->{$_}[1], $irc{'stats'}->{'domain'}->{$_}[2]);
      $sth   = $dbh->prepare($query);
      $sth->execute;
      $sth->finish;
    }

    $query = sprintf("DELETE FROM %s", $cfg{'mysql-tchannel'});
    $sth   = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    foreach (keys %{$irc{'channel'}}) {
      my ($modes, $users, $banlist, $exclist, $geclist);
      my (@op, @half, @voice, @user);

      foreach my $nick (keys %{$irc{'channel'}->{$_}->{'names'}}) {
        if ($irc{'channel'}->{$_}->{'names'}->{lc($nick)}->{'mode'} & $flags{'channel'}->{'o'}) {
          push @op, $irc{'channel'}->{$_}->{'names'}->{lc($nick)}->{'nick'};
        } elsif ($irc{'channel'}->{$_}->{'names'}->{lc($nick)}->{'mode'} & $flags{'channel'}->{'h'}) {
          push @half, $irc{'channel'}->{$_}->{'names'}->{lc($nick)}->{'nick'};
        } elsif ($irc{'channel'}->{$_}->{'names'}->{lc($nick)}->{'mode'} & $flags{'channel'}->{'v'}) {
          push @voice, $irc{'channel'}->{$_}->{'names'}->{lc($nick)}->{'nick'};
        } else {
          push @user, $irc{'channel'}->{$_}->{'names'}->{lc($nick)}->{'nick'};
        }
      }

      @op    = sort @op;
      @half  = sort @half;
      @voice = sort @voice;
      @user  = sort @user;

      foreach (@op) { $users .= "\@" . $_ . " "; }
      foreach (@half) { $users .= "\%" . $_ . " "; }
      foreach (@voice) { $users .= "+" . $_ . " "; }
      foreach (@user) { $users .= $_ . " "; }

      $users =~ tr/ //s; $users =~ s/\s+$//;

      if (exists $irc{'channel'}->{$_}->{'banlist'}) { foreach my $ban (keys %{$irc{'channel'}->{$_}->{'banlist'}}) { $banlist .= $irc{'channel'}->{$_}->{'banlist'}->{$ban}[0] . " "; } }
      if (exists $irc{'channel'}->{$_}->{'exclist'}) { foreach my $exc (keys %{$irc{'channel'}->{$_}->{'exclist'}}) { $exclist .= $irc{'channel'}->{$_}->{'exclist'}->{$exc}[0] . " "; } }
      if (exists $irc{'channel'}->{$_}->{'geclist'}) { foreach my $gec (keys %{$irc{'channel'}->{$_}->{'geclist'}}) { $geclist .= $irc{'channel'}->{$_}->{'geclist'}->{$gec}[0] . " "; } }

      $banlist =~ s/\s+$//;
      $exclist =~ s/\s+$//;
      $geclist =~ s/\s+$//;

      foreach my $mode (keys %{$flags{'channel'}}) {
        if ($irc{'channel'}->{$_}->{'mode'} & $flags{'channel'}->{$mode}) { $modes .= $mode; }
      }

      $query = sprintf("INSERT INTO %s \(channel, time, mode, topic, author, timeset, users, maxusers, maxuserstime, banlist, exclist, geclist\) VALUES \(\'%s\', \'%d\', \'%s\', \'%s\', \'%s\', \'%d\', \'%s\', \'%d\', \'%d\', \'%s\', \'%s\', \'%s\'\)", $cfg{'mysql-tchannel'}, $irc{'channel'}->{$_}->{'channel'}, $irc{'channel'}->{$_}->{'time'}, $modes, $irc{'channel'}->{$_}->{'topic'}[0], $irc{'channel'}->{$_}->{'topic'}[1], $irc{'channel'}->{$_}->{'topic'}[2], $users,  $irc{'channel'}->{$_}->{'max'}[0], $irc{'channel'}->{$_}->{'max'}[1], $banlist, $exclist, $geclist);
      $sth   = $dbh->prepare($query);
      $sth->execute;
      $sth->finish;
    }

    $dbh->disconnect;
    &putinfo("y", "MySQL stats have been saved");
    exit(0);
  }

  return 0;
}

1;